Package ghidra.framework.store

# Interface DataFileHandle

All Known Implementing Classes:
  `LocalDataFileHandle`

public interface DataFileHandle
`DataFileHandle` provides a random-access handle to a file.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Closes this random access file stream and releases any system resources associated with the stream.
  `boolean`
  `isReadOnly()`
  Returns true if this data file handle is open read-only.
  `long`
  `length()`
  Returns the length of this file.
  `void`
  `read(byte[] b)`
  Reads `b.length` bytes from this file into the byte array, starting at the current file pointer.
  `void`
  `read(byte[] b, int off, int len)`
  Reads exactly `len` bytes from this file into the byte array, starting at the current file pointer.
  `void`
  `seek(long pos)`
  Sets the file-pointer offset, measured from the beginning of this file, at which the next read or write occurs.
  `void`
  `setLength(long newLength)`
  Sets the length of this file.
  `int`
  `skipBytes(int n)`
  Attempts to skip over `n` bytes of input discarding the skipped bytes.
  `void`
  `write(byte[] b)`
  Writes `b.length` bytes from the specified byte array to this file, starting at the current file pointer.
  `void`
  `write(byte[] b, int off, int len)`
  Writes `len` bytes from the specified byte array starting at offset `off` to this file.
  `void`
  `write(int b)`
  Writes the specified byte to this file.

- ## Method Details

  - ### isReadOnly

    boolean isReadOnly() throws IOException
    Returns true if this data file handle is open read-only.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### read

    void read(byte[] b) throws IOException
    Reads `b.length` bytes from this file into the byte array, starting at the current file pointer. This method reads repeatedly from the file until the requested number of bytes are read. This method blocks until the requested number of bytes are read, the end of the stream is detected, or an exception is thrown.
    Parameters:
      `b` - the buffer into which the data is read.
    Throws:
      `EOFException` - if this file reaches the end before reading all the bytes.
      `IOException` - if an I/O error occurs.

  - ### read

    void read(byte[] b, int off, int len) throws IOException
    Reads exactly `len` bytes from this file into the byte array, starting at the current file pointer. This method reads repeatedly from the file until the requested number of bytes are read. This method blocks until the requested number of bytes are read, the end of the stream is detected, or an exception is thrown.
    Parameters:
      `b` - the buffer into which the data is read.
      `off` - the start offset of the data.
      `len` - the number of bytes to read.
    Throws:
      `EOFException` - if this file reaches the end before reading all the bytes.
      `IOException` - if an I/O error occurs.

  - ### skipBytes

    int skipBytes(int n) throws IOException
    Attempts to skip over `n` bytes of input discarding the skipped bytes.

    This method may skip over some smaller number of bytes, possibly zero. This may result from any of a number of conditions; reaching end of file before `n` bytes have been skipped is only one possibility. This method never throws an `EOFException`. The actual number of bytes skipped is returned. If `n` is negative, no bytes are skipped.

    Parameters:
      `n` - the number of bytes to be skipped.
    Returns:
      the actual number of bytes skipped.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### write

    void write(int b) throws IOException
    Writes the specified byte to this file. The write starts at the current file pointer.
    Parameters:
      `b` - the `byte` to be written.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### write

    void write(byte[] b) throws IOException
    Writes `b.length` bytes from the specified byte array to this file, starting at the current file pointer.
    Parameters:
      `b` - the data.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### write

    void write(byte[] b, int off, int len) throws IOException
    Writes `len` bytes from the specified byte array starting at offset `off` to this file.
    Parameters:
      `b` - the data.
      `off` - the start offset in the data.
      `len` - the number of bytes to write.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### seek

    void seek(long pos) throws IOException
    Sets the file-pointer offset, measured from the beginning of this file, at which the next read or write occurs. The offset may be set beyond the end of the file. Setting the offset beyond the end of the file does not change the file length. The file length will change only by writing after the offset has been set beyond the end of the file.
    Parameters:
      `pos` - the offset position, measured in bytes from the beginning of the file, at which to set the file pointer.
    Throws:
      `IOException` - if `pos` is less than `0` or if an I/O error occurs.

  - ### length

    long length() throws IOException
    Returns the length of this file.
    Returns:
      the length of this file, measured in bytes.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### setLength

    void setLength(long newLength) throws IOException
    Sets the length of this file.

    If the present length of the file as returned by the `length` method is greater than the `newLength` argument then the file will be truncated. In this case, if the file offset as returned by the `getFilePointer` method is greater then `newLength` then after this method returns the offset will be equal to `newLength`.

    If the present length of the file as returned by the `length` method is smaller than the `newLength` argument then the file will be extended. In this case, the contents of the extended portion of the file are not defined.

    Parameters:
      `newLength` - The desired length of the file
    Throws:
      `IOException` - If an I/O error occurs

  - ### close

    void close() throws IOException
    Closes this random access file stream and releases any system resources associated with the stream. A closed random access file cannot perform input or output operations and cannot be reopened.
    Throws:
      `IOException` - if an I/O error occurs.